/* ************************************************************************** */
/*                                                                            */
/*  monochrome/internals.h                                                    */
/*  | Project : libmonochrome                                                 */
/*                                                                            */
/*  By: Pierre "PierrotLL" Le Gall <legallpierre89@gmail.com>                 */
/*  Last updated: 2011/11/22                                                  */
/*                                                                            */
/* ************************************************************************** */

#ifndef MONOCHROME_INTERNALS_H
# define MONOCHROME_INTERNALS_H

# include <stddef.h>
# include <monochrome.h>
# define sgn(x) (x < 0 ? -1 : 1)
# define rnd(x) ((int)x + 0.5)

/*
**	STDLIB Prototypes
*/

void		*malloc(size_t size);
void		free(void *ptr);

#endif
