/* ************************************************************************** */
/*                                                                            */
/*  ML_vram_address.c                                                         */
/*  | Project : libmonochrome                                                 */
/*                                                                            */
/*  By: Pierre "PierrotLL" Le Gall <legallpierre89@gmail.com>                 */
/*  Last updated: 2011/11/22                                                  */
/*                                                                            */
/* ************************************************************************** */

#include <monochrome/internals.h>

// Syscall 0x135 (Thanks to Simon Lothar for this function)
typedef char*(*sc_cpv)(void);
const unsigned int sc0135[] = {0xD201D002, 0x422B0009, 0x80010070, 0x0135};

void* ML_vram_address()
{
	return ((sc_cpv)sc0135)();
}
